#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main()
{
   ios::sync_with_stdio(false);
   cin.tie(0);
   int n, k;
   cin >> n >> k;
   vector<int> a(n + 1);
   for(int i = 1; i <= n; i++) {
    char x;
    cin >> x;
    a[i] = x - 'a';
   }
   string c = "";
   map<int,int> M;
   map<int,int> M1;
   map<int,int> M2;
   for(int i = 1; i <= n; i++) {
        M[a[i]] += 1;
        if(!M1[a[i]]) {
            M1[a[i]] = i;
            M2[a[i]] = i;
        }
        else {
            M2[a[i]] = i;
        }
        int ok = 0;
        for(int j = 0; j < k; j++) {
            if(!M[j]) {
                ok = 1;
            }
        }
        if(ok) {
            cout << 1 << " ";
        }
        else {
            for(int j = 0; j < k; j++) {
                for(int k = 0; k < j; k++) {
                    if(M2[j] < M1[k]) {
                        ok = 1;
                    }
                }
            }
            for(int j = 0; j < k; j++) {
                if(M[j] == 1) {
                    ok = 1;
                }
            }
            if(ok) {
                cout << 2 << " ";
            }
            else {
                cout << 3 << " ";
            }
        }
   }
}